"use strict";

// node_modules/@lit-labs/ssr-dom-shim/lib/element-internals.js
var ElementInternalsShim = class ElementInternals {
  get shadowRoot() {
    return this.__host.__shadowRoot;
  }
  constructor(_host) {
    this.ariaAtomic = "";
    this.ariaAutoComplete = "";
    this.ariaBraileLabel = "";
    this.ariaBraileRoleDescription = "";
    this.ariaBusy = "";
    this.ariaChecked = "";
    this.ariaColCount = "";
    this.ariaColIndex = "";
    this.ariaColSpan = "";
    this.ariaCurrent = "";
    this.ariaDescription = "";
    this.ariaDisabled = "";
    this.ariaExpanded = "";
    this.ariaHasPopup = "";
    this.ariaHidden = "";
    this.ariaInvalid = "";
    this.ariaKeyShortcuts = "";
    this.ariaLabel = "";
    this.ariaLevel = "";
    this.ariaLive = "";
    this.ariaModal = "";
    this.ariaMultiLine = "";
    this.ariaMultiSelectable = "";
    this.ariaOrientation = "";
    this.ariaPlaceholder = "";
    this.ariaPosInSet = "";
    this.ariaPressed = "";
    this.ariaReadOnly = "";
    this.ariaRequired = "";
    this.ariaRoleDescription = "";
    this.ariaRowCount = "";
    this.ariaRowIndex = "";
    this.ariaRowSpan = "";
    this.ariaSelected = "";
    this.ariaSetSize = "";
    this.ariaSort = "";
    this.ariaValueMax = "";
    this.ariaValueMin = "";
    this.ariaValueNow = "";
    this.ariaValueText = "";
    this.role = "";
    this.form = null;
    this.labels = [];
    this.states = /* @__PURE__ */ new Set();
    this.validationMessage = "";
    this.validity = {};
    this.willValidate = true;
    this.__host = _host;
  }
  checkValidity() {
    console.warn("`ElementInternals.checkValidity()` was called on the server.This method always returns true.");
    return true;
  }
  reportValidity() {
    return true;
  }
  setFormValue() {
  }
  setValidity() {
  }
};

// node_modules/@lit-labs/ssr-dom-shim/index.js
var attributes = /* @__PURE__ */ new WeakMap();
var attributesForElement = (element) => {
  let attrs = attributes.get(element);
  if (attrs === void 0) {
    attributes.set(element, attrs = /* @__PURE__ */ new Map());
  }
  return attrs;
};
var ElementShim = class Element {
  constructor() {
    this.__shadowRootMode = null;
    this.__shadowRoot = null;
    this.__internals = null;
  }
  get attributes() {
    return Array.from(attributesForElement(this)).map(([name, value]) => ({
      name,
      value
    }));
  }
  get shadowRoot() {
    if (this.__shadowRootMode === "closed") {
      return null;
    }
    return this.__shadowRoot;
  }
  setAttribute(name, value) {
    attributesForElement(this).set(name, String(value));
  }
  removeAttribute(name) {
    attributesForElement(this).delete(name);
  }
  toggleAttribute(name, force) {
    if (this.hasAttribute(name)) {
      if (force === void 0 || !force) {
        this.removeAttribute(name);
        return false;
      }
    } else {
      if (force === void 0 || force) {
        this.setAttribute(name, "");
        return true;
      } else {
        return false;
      }
    }
    return true;
  }
  hasAttribute(name) {
    return attributesForElement(this).has(name);
  }
  attachShadow(init) {
    const shadowRoot = { host: this };
    this.__shadowRootMode = init.mode;
    if (init && init.mode === "open") {
      this.__shadowRoot = shadowRoot;
    }
    return shadowRoot;
  }
  attachInternals() {
    if (this.__internals !== null) {
      throw new Error(`Failed to execute 'attachInternals' on 'HTMLElement': ElementInternals for the specified element was already attached.`);
    }
    const internals = new ElementInternalsShim(this);
    this.__internals = internals;
    return internals;
  }
  getAttribute(name) {
    const value = attributesForElement(this).get(name);
    return value ?? null;
  }
};
var HTMLElementShim = class HTMLElement extends ElementShim {
};
var HTMLElementShimWithRealType = HTMLElementShim;
var CustomElementRegistryShim = class CustomElementRegistry {
  constructor() {
    this.__definitions = /* @__PURE__ */ new Map();
  }
  define(name, ctor) {
    if (this.__definitions.has(name)) {
      if (process.env.NODE_ENV === "development") {
        console.warn(`'CustomElementRegistry' already has "${name}" defined. This may have been caused by live reload or hot module replacement in which case it can be safely ignored.
Make sure to test your application with a production build as repeat registrations will throw in production.`);
      } else {
        throw new Error(`Failed to execute 'define' on 'CustomElementRegistry': the name "${name}" has already been used with this registry`);
      }
    }
    this.__definitions.set(name, {
      ctor,
      // Note it's important we read `observedAttributes` in case it is a getter
      // with side-effects, as is the case in Lit, where it triggers class
      // finalization.
      //
      // TODO(aomarks) To be spec compliant, we should also capture the
      // registration-time lifecycle methods like `connectedCallback`. For them
      // to be actually accessible to e.g. the Lit SSR element renderer, though,
      // we'd need to introduce a new API for accessing them (since `get` only
      // returns the constructor).
      observedAttributes: ctor.observedAttributes ?? []
    });
  }
  get(name) {
    const definition = this.__definitions.get(name);
    return definition?.ctor;
  }
};
var CustomElementRegistryShimWithRealType = CustomElementRegistryShim;
var customElements2 = new CustomElementRegistryShimWithRealType();

// node_modules/@lit/reactive-element/node/css-tag.js
var t = globalThis;
var e = t.ShadowRoot && (void 0 === t.ShadyCSS || t.ShadyCSS.nativeShadow) && "adoptedStyleSheets" in Document.prototype && "replace" in CSSStyleSheet.prototype;
var s = Symbol();
var o = /* @__PURE__ */ new WeakMap();
var n = class {
  constructor(t5, e5, o6) {
    if (this._$cssResult$ = true, o6 !== s) throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");
    this.cssText = t5, this.t = e5;
  }
  get styleSheet() {
    let t5 = this.o;
    const s7 = this.t;
    if (e && void 0 === t5) {
      const e5 = void 0 !== s7 && 1 === s7.length;
      e5 && (t5 = o.get(s7)), void 0 === t5 && ((this.o = t5 = new CSSStyleSheet()).replaceSync(this.cssText), e5 && o.set(s7, t5));
    }
    return t5;
  }
  toString() {
    return this.cssText;
  }
};
var r = (t5) => new n("string" == typeof t5 ? t5 : t5 + "", void 0, s);
var i = (t5, ...e5) => {
  const o6 = 1 === t5.length ? t5[0] : e5.reduce((e6, s7, o7) => e6 + ((t6) => {
    if (true === t6._$cssResult$) return t6.cssText;
    if ("number" == typeof t6) return t6;
    throw Error("Value passed to 'css' function must be a 'css' function result: " + t6 + ". Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.");
  })(s7) + t5[o7 + 1], t5[0]);
  return new n(o6, t5, s);
};
var S = (s7, o6) => {
  if (e) s7.adoptedStyleSheets = o6.map((t5) => t5 instanceof CSSStyleSheet ? t5 : t5.styleSheet);
  else for (const e5 of o6) {
    const o7 = document.createElement("style"), n7 = t.litNonce;
    void 0 !== n7 && o7.setAttribute("nonce", n7), o7.textContent = e5.cssText, s7.appendChild(o7);
  }
};
var c = e || void 0 === t.CSSStyleSheet ? (t5) => t5 : (t5) => t5 instanceof CSSStyleSheet ? ((t6) => {
  let e5 = "";
  for (const s7 of t6.cssRules) e5 += s7.cssText;
  return r(e5);
})(t5) : t5;

// node_modules/@lit/reactive-element/node/reactive-element.js
var { is: r2, defineProperty: h, getOwnPropertyDescriptor: o2, getOwnPropertyNames: n2, getOwnPropertySymbols: a, getPrototypeOf: c2 } = Object;
var l = globalThis;
l.customElements ??= customElements2;
var p = l.trustedTypes;
var d = p ? p.emptyScript : "";
var u = l.reactiveElementPolyfillSupport;
var f = (t5, s7) => t5;
var b = { toAttribute(t5, s7) {
  switch (s7) {
    case Boolean:
      t5 = t5 ? d : null;
      break;
    case Object:
    case Array:
      t5 = null == t5 ? t5 : JSON.stringify(t5);
  }
  return t5;
}, fromAttribute(t5, s7) {
  let i6 = t5;
  switch (s7) {
    case Boolean:
      i6 = null !== t5;
      break;
    case Number:
      i6 = null === t5 ? null : Number(t5);
      break;
    case Object:
    case Array:
      try {
        i6 = JSON.parse(t5);
      } catch (t6) {
        i6 = null;
      }
  }
  return i6;
} };
var y = (t5, s7) => !r2(t5, s7);
var m = { attribute: true, type: String, converter: b, reflect: false, hasChanged: y };
Symbol.metadata ??= Symbol("metadata"), l.litPropertyMetadata ??= /* @__PURE__ */ new WeakMap();
var g = class extends (globalThis.HTMLElement ?? HTMLElementShimWithRealType) {
  static addInitializer(t5) {
    this._$Ei(), (this.l ??= []).push(t5);
  }
  static get observedAttributes() {
    return this.finalize(), this._$Eh && [...this._$Eh.keys()];
  }
  static createProperty(t5, s7 = m) {
    if (s7.state && (s7.attribute = false), this._$Ei(), this.elementProperties.set(t5, s7), !s7.noAccessor) {
      const i6 = Symbol(), e5 = this.getPropertyDescriptor(t5, i6, s7);
      void 0 !== e5 && h(this.prototype, t5, e5);
    }
  }
  static getPropertyDescriptor(t5, s7, i6) {
    const { get: e5, set: r7 } = o2(this.prototype, t5) ?? { get() {
      return this[s7];
    }, set(t6) {
      this[s7] = t6;
    } };
    return { get() {
      return e5?.call(this);
    }, set(s8) {
      const h7 = e5?.call(this);
      r7.call(this, s8), this.requestUpdate(t5, h7, i6);
    }, configurable: true, enumerable: true };
  }
  static getPropertyOptions(t5) {
    return this.elementProperties.get(t5) ?? m;
  }
  static _$Ei() {
    if (this.hasOwnProperty(f("elementProperties"))) return;
    const t5 = c2(this);
    t5.finalize(), void 0 !== t5.l && (this.l = [...t5.l]), this.elementProperties = new Map(t5.elementProperties);
  }
  static finalize() {
    if (this.hasOwnProperty(f("finalized"))) return;
    if (this.finalized = true, this._$Ei(), this.hasOwnProperty(f("properties"))) {
      const t6 = this.properties, s7 = [...n2(t6), ...a(t6)];
      for (const i6 of s7) this.createProperty(i6, t6[i6]);
    }
    const t5 = this[Symbol.metadata];
    if (null !== t5) {
      const s7 = litPropertyMetadata.get(t5);
      if (void 0 !== s7) for (const [t6, i6] of s7) this.elementProperties.set(t6, i6);
    }
    this._$Eh = /* @__PURE__ */ new Map();
    for (const [t6, s7] of this.elementProperties) {
      const i6 = this._$Eu(t6, s7);
      void 0 !== i6 && this._$Eh.set(i6, t6);
    }
    this.elementStyles = this.finalizeStyles(this.styles);
  }
  static finalizeStyles(t5) {
    const s7 = [];
    if (Array.isArray(t5)) {
      const e5 = new Set(t5.flat(1 / 0).reverse());
      for (const t6 of e5) s7.unshift(c(t6));
    } else void 0 !== t5 && s7.push(c(t5));
    return s7;
  }
  static _$Eu(t5, s7) {
    const i6 = s7.attribute;
    return false === i6 ? void 0 : "string" == typeof i6 ? i6 : "string" == typeof t5 ? t5.toLowerCase() : void 0;
  }
  constructor() {
    super(), this._$Ep = void 0, this.isUpdatePending = false, this.hasUpdated = false, this._$Em = null, this._$Ev();
  }
  _$Ev() {
    this._$ES = new Promise((t5) => this.enableUpdating = t5), this._$AL = /* @__PURE__ */ new Map(), this._$E_(), this.requestUpdate(), this.constructor.l?.forEach((t5) => t5(this));
  }
  addController(t5) {
    (this._$EO ??= /* @__PURE__ */ new Set()).add(t5), void 0 !== this.renderRoot && this.isConnected && t5.hostConnected?.();
  }
  removeController(t5) {
    this._$EO?.delete(t5);
  }
  _$E_() {
    const t5 = /* @__PURE__ */ new Map(), s7 = this.constructor.elementProperties;
    for (const i6 of s7.keys()) this.hasOwnProperty(i6) && (t5.set(i6, this[i6]), delete this[i6]);
    t5.size > 0 && (this._$Ep = t5);
  }
  createRenderRoot() {
    const t5 = this.shadowRoot ?? this.attachShadow(this.constructor.shadowRootOptions);
    return S(t5, this.constructor.elementStyles), t5;
  }
  connectedCallback() {
    this.renderRoot ??= this.createRenderRoot(), this.enableUpdating(true), this._$EO?.forEach((t5) => t5.hostConnected?.());
  }
  enableUpdating(t5) {
  }
  disconnectedCallback() {
    this._$EO?.forEach((t5) => t5.hostDisconnected?.());
  }
  attributeChangedCallback(t5, s7, i6) {
    this._$AK(t5, i6);
  }
  _$EC(t5, s7) {
    const i6 = this.constructor.elementProperties.get(t5), e5 = this.constructor._$Eu(t5, i6);
    if (void 0 !== e5 && true === i6.reflect) {
      const r7 = (void 0 !== i6.converter?.toAttribute ? i6.converter : b).toAttribute(s7, i6.type);
      this._$Em = t5, null == r7 ? this.removeAttribute(e5) : this.setAttribute(e5, r7), this._$Em = null;
    }
  }
  _$AK(t5, s7) {
    const i6 = this.constructor, e5 = i6._$Eh.get(t5);
    if (void 0 !== e5 && this._$Em !== e5) {
      const t6 = i6.getPropertyOptions(e5), r7 = "function" == typeof t6.converter ? { fromAttribute: t6.converter } : void 0 !== t6.converter?.fromAttribute ? t6.converter : b;
      this._$Em = e5, this[e5] = r7.fromAttribute(s7, t6.type), this._$Em = null;
    }
  }
  requestUpdate(t5, s7, i6) {
    if (void 0 !== t5) {
      if (i6 ??= this.constructor.getPropertyOptions(t5), !(i6.hasChanged ?? y)(this[t5], s7)) return;
      this.P(t5, s7, i6);
    }
    false === this.isUpdatePending && (this._$ES = this._$ET());
  }
  P(t5, s7, i6) {
    this._$AL.has(t5) || this._$AL.set(t5, s7), true === i6.reflect && this._$Em !== t5 && (this._$Ej ??= /* @__PURE__ */ new Set()).add(t5);
  }
  async _$ET() {
    this.isUpdatePending = true;
    try {
      await this._$ES;
    } catch (t6) {
      Promise.reject(t6);
    }
    const t5 = this.scheduleUpdate();
    return null != t5 && await t5, !this.isUpdatePending;
  }
  scheduleUpdate() {
    return this.performUpdate();
  }
  performUpdate() {
    if (!this.isUpdatePending) return;
    if (!this.hasUpdated) {
      if (this.renderRoot ??= this.createRenderRoot(), this._$Ep) {
        for (const [t7, s8] of this._$Ep) this[t7] = s8;
        this._$Ep = void 0;
      }
      const t6 = this.constructor.elementProperties;
      if (t6.size > 0) for (const [s8, i6] of t6) true !== i6.wrapped || this._$AL.has(s8) || void 0 === this[s8] || this.P(s8, this[s8], i6);
    }
    let t5 = false;
    const s7 = this._$AL;
    try {
      t5 = this.shouldUpdate(s7), t5 ? (this.willUpdate(s7), this._$EO?.forEach((t6) => t6.hostUpdate?.()), this.update(s7)) : this._$EU();
    } catch (s8) {
      throw t5 = false, this._$EU(), s8;
    }
    t5 && this._$AE(s7);
  }
  willUpdate(t5) {
  }
  _$AE(t5) {
    this._$EO?.forEach((t6) => t6.hostUpdated?.()), this.hasUpdated || (this.hasUpdated = true, this.firstUpdated(t5)), this.updated(t5);
  }
  _$EU() {
    this._$AL = /* @__PURE__ */ new Map(), this.isUpdatePending = false;
  }
  get updateComplete() {
    return this.getUpdateComplete();
  }
  getUpdateComplete() {
    return this._$ES;
  }
  shouldUpdate(t5) {
    return true;
  }
  update(t5) {
    this._$Ej &&= this._$Ej.forEach((t6) => this._$EC(t6, this[t6])), this._$EU();
  }
  updated(t5) {
  }
  firstUpdated(t5) {
  }
};
g.elementStyles = [], g.shadowRootOptions = { mode: "open" }, g[f("elementProperties")] = /* @__PURE__ */ new Map(), g[f("finalized")] = /* @__PURE__ */ new Map(), u?.({ ReactiveElement: g }), (l.reactiveElementVersions ??= []).push("2.0.4");

// node_modules/lit-html/node/lit-html.js
var t2 = globalThis;
var i2 = t2.trustedTypes;
var s2 = i2 ? i2.createPolicy("lit-html", { createHTML: (t5) => t5 }) : void 0;
var e2 = "$lit$";
var h2 = `lit$${Math.random().toFixed(9).slice(2)}$`;
var o3 = "?" + h2;
var n3 = `<${o3}>`;
var r3 = void 0 === t2.document ? { createTreeWalker: () => ({}) } : document;
var l2 = () => r3.createComment("");
var c3 = (t5) => null === t5 || "object" != typeof t5 && "function" != typeof t5;
var a2 = Array.isArray;
var u2 = (t5) => a2(t5) || "function" == typeof t5?.[Symbol.iterator];
var d2 = "[ 	\n\f\r]";
var f2 = /<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g;
var v = /-->/g;
var _ = />/g;
var m2 = RegExp(`>|${d2}(?:([^\\s"'>=/]+)(${d2}*=${d2}*(?:[^ 	
\f\r"'\`<>=]|("|')|))|$)`, "g");
var p2 = /'/g;
var g2 = /"/g;
var $ = /^(?:script|style|textarea|title)$/i;
var y2 = (t5) => (i6, ...s7) => ({ _$litType$: t5, strings: i6, values: s7 });
var x = y2(1);
var T = y2(2);
var b2 = Symbol.for("lit-noChange");
var w = Symbol.for("lit-nothing");
var A = /* @__PURE__ */ new WeakMap();
var E = r3.createTreeWalker(r3, 129);
function C(t5, i6) {
  if (!Array.isArray(t5) || !t5.hasOwnProperty("raw")) throw Error("invalid template strings array");
  return void 0 !== s2 ? s2.createHTML(i6) : i6;
}
var P = (t5, i6) => {
  const s7 = t5.length - 1, o6 = [];
  let r7, l3 = 2 === i6 ? "<svg>" : "", c7 = f2;
  for (let i7 = 0; i7 < s7; i7++) {
    const s8 = t5[i7];
    let a3, u5, d3 = -1, y3 = 0;
    for (; y3 < s8.length && (c7.lastIndex = y3, u5 = c7.exec(s8), null !== u5); ) y3 = c7.lastIndex, c7 === f2 ? "!--" === u5[1] ? c7 = v : void 0 !== u5[1] ? c7 = _ : void 0 !== u5[2] ? ($.test(u5[2]) && (r7 = RegExp("</" + u5[2], "g")), c7 = m2) : void 0 !== u5[3] && (c7 = m2) : c7 === m2 ? ">" === u5[0] ? (c7 = r7 ?? f2, d3 = -1) : void 0 === u5[1] ? d3 = -2 : (d3 = c7.lastIndex - u5[2].length, a3 = u5[1], c7 = void 0 === u5[3] ? m2 : '"' === u5[3] ? g2 : p2) : c7 === g2 || c7 === p2 ? c7 = m2 : c7 === v || c7 === _ ? c7 = f2 : (c7 = m2, r7 = void 0);
    const x2 = c7 === m2 && t5[i7 + 1].startsWith("/>") ? " " : "";
    l3 += c7 === f2 ? s8 + n3 : d3 >= 0 ? (o6.push(a3), s8.slice(0, d3) + e2 + s8.slice(d3) + h2 + x2) : s8 + h2 + (-2 === d3 ? i7 : x2);
  }
  return [C(t5, l3 + (t5[s7] || "<?>") + (2 === i6 ? "</svg>" : "")), o6];
};
var V = class _V {
  constructor({ strings: t5, _$litType$: s7 }, n7) {
    let r7;
    this.parts = [];
    let c7 = 0, a3 = 0;
    const u5 = t5.length - 1, d3 = this.parts, [f5, v3] = P(t5, s7);
    if (this.el = _V.createElement(f5, n7), E.currentNode = this.el.content, 2 === s7) {
      const t6 = this.el.content.firstChild;
      t6.replaceWith(...t6.childNodes);
    }
    for (; null !== (r7 = E.nextNode()) && d3.length < u5; ) {
      if (1 === r7.nodeType) {
        if (r7.hasAttributes()) for (const t6 of r7.getAttributeNames()) if (t6.endsWith(e2)) {
          const i6 = v3[a3++], s8 = r7.getAttribute(t6).split(h2), e5 = /([.?@])?(.*)/.exec(i6);
          d3.push({ type: 1, index: c7, name: e5[2], strings: s8, ctor: "." === e5[1] ? R : "?" === e5[1] ? H : "@" === e5[1] ? I : k }), r7.removeAttribute(t6);
        } else t6.startsWith(h2) && (d3.push({ type: 6, index: c7 }), r7.removeAttribute(t6));
        if ($.test(r7.tagName)) {
          const t6 = r7.textContent.split(h2), s8 = t6.length - 1;
          if (s8 > 0) {
            r7.textContent = i2 ? i2.emptyScript : "";
            for (let i6 = 0; i6 < s8; i6++) r7.append(t6[i6], l2()), E.nextNode(), d3.push({ type: 2, index: ++c7 });
            r7.append(t6[s8], l2());
          }
        }
      } else if (8 === r7.nodeType) if (r7.data === o3) d3.push({ type: 2, index: c7 });
      else {
        let t6 = -1;
        for (; -1 !== (t6 = r7.data.indexOf(h2, t6 + 1)); ) d3.push({ type: 7, index: c7 }), t6 += h2.length - 1;
      }
      c7++;
    }
  }
  static createElement(t5, i6) {
    const s7 = r3.createElement("template");
    return s7.innerHTML = t5, s7;
  }
};
function N(t5, i6, s7 = t5, e5) {
  if (i6 === b2) return i6;
  let h7 = void 0 !== e5 ? s7._$Co?.[e5] : s7._$Cl;
  const o6 = c3(i6) ? void 0 : i6._$litDirective$;
  return h7?.constructor !== o6 && (h7?._$AO?.(false), void 0 === o6 ? h7 = void 0 : (h7 = new o6(t5), h7._$AT(t5, s7, e5)), void 0 !== e5 ? (s7._$Co ??= [])[e5] = h7 : s7._$Cl = h7), void 0 !== h7 && (i6 = N(t5, h7._$AS(t5, i6.values), h7, e5)), i6;
}
var S2 = class {
  constructor(t5, i6) {
    this._$AV = [], this._$AN = void 0, this._$AD = t5, this._$AM = i6;
  }
  get parentNode() {
    return this._$AM.parentNode;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  u(t5) {
    const { el: { content: i6 }, parts: s7 } = this._$AD, e5 = (t5?.creationScope ?? r3).importNode(i6, true);
    E.currentNode = e5;
    let h7 = E.nextNode(), o6 = 0, n7 = 0, l3 = s7[0];
    for (; void 0 !== l3; ) {
      if (o6 === l3.index) {
        let i7;
        2 === l3.type ? i7 = new M(h7, h7.nextSibling, this, t5) : 1 === l3.type ? i7 = new l3.ctor(h7, l3.name, l3.strings, this, t5) : 6 === l3.type && (i7 = new L(h7, this, t5)), this._$AV.push(i7), l3 = s7[++n7];
      }
      o6 !== l3?.index && (h7 = E.nextNode(), o6++);
    }
    return E.currentNode = r3, e5;
  }
  p(t5) {
    let i6 = 0;
    for (const s7 of this._$AV) void 0 !== s7 && (void 0 !== s7.strings ? (s7._$AI(t5, s7, i6), i6 += s7.strings.length - 2) : s7._$AI(t5[i6])), i6++;
  }
};
var M = class _M {
  get _$AU() {
    return this._$AM?._$AU ?? this._$Cv;
  }
  constructor(t5, i6, s7, e5) {
    this.type = 2, this._$AH = w, this._$AN = void 0, this._$AA = t5, this._$AB = i6, this._$AM = s7, this.options = e5, this._$Cv = e5?.isConnected ?? true;
  }
  get parentNode() {
    let t5 = this._$AA.parentNode;
    const i6 = this._$AM;
    return void 0 !== i6 && 11 === t5?.nodeType && (t5 = i6.parentNode), t5;
  }
  get startNode() {
    return this._$AA;
  }
  get endNode() {
    return this._$AB;
  }
  _$AI(t5, i6 = this) {
    t5 = N(this, t5, i6), c3(t5) ? t5 === w || null == t5 || "" === t5 ? (this._$AH !== w && this._$AR(), this._$AH = w) : t5 !== this._$AH && t5 !== b2 && this._(t5) : void 0 !== t5._$litType$ ? this.$(t5) : void 0 !== t5.nodeType ? this.T(t5) : u2(t5) ? this.k(t5) : this._(t5);
  }
  S(t5) {
    return this._$AA.parentNode.insertBefore(t5, this._$AB);
  }
  T(t5) {
    this._$AH !== t5 && (this._$AR(), this._$AH = this.S(t5));
  }
  _(t5) {
    this._$AH !== w && c3(this._$AH) ? this._$AA.nextSibling.data = t5 : this.T(r3.createTextNode(t5)), this._$AH = t5;
  }
  $(t5) {
    const { values: i6, _$litType$: s7 } = t5, e5 = "number" == typeof s7 ? this._$AC(t5) : (void 0 === s7.el && (s7.el = V.createElement(C(s7.h, s7.h[0]), this.options)), s7);
    if (this._$AH?._$AD === e5) this._$AH.p(i6);
    else {
      const t6 = new S2(e5, this), s8 = t6.u(this.options);
      t6.p(i6), this.T(s8), this._$AH = t6;
    }
  }
  _$AC(t5) {
    let i6 = A.get(t5.strings);
    return void 0 === i6 && A.set(t5.strings, i6 = new V(t5)), i6;
  }
  k(t5) {
    a2(this._$AH) || (this._$AH = [], this._$AR());
    const i6 = this._$AH;
    let s7, e5 = 0;
    for (const h7 of t5) e5 === i6.length ? i6.push(s7 = new _M(this.S(l2()), this.S(l2()), this, this.options)) : s7 = i6[e5], s7._$AI(h7), e5++;
    e5 < i6.length && (this._$AR(s7 && s7._$AB.nextSibling, e5), i6.length = e5);
  }
  _$AR(t5 = this._$AA.nextSibling, i6) {
    for (this._$AP?.(false, true, i6); t5 && t5 !== this._$AB; ) {
      const i7 = t5.nextSibling;
      t5.remove(), t5 = i7;
    }
  }
  setConnected(t5) {
    void 0 === this._$AM && (this._$Cv = t5, this._$AP?.(t5));
  }
};
var k = class {
  get tagName() {
    return this.element.tagName;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  constructor(t5, i6, s7, e5, h7) {
    this.type = 1, this._$AH = w, this._$AN = void 0, this.element = t5, this.name = i6, this._$AM = e5, this.options = h7, s7.length > 2 || "" !== s7[0] || "" !== s7[1] ? (this._$AH = Array(s7.length - 1).fill(new String()), this.strings = s7) : this._$AH = w;
  }
  _$AI(t5, i6 = this, s7, e5) {
    const h7 = this.strings;
    let o6 = false;
    if (void 0 === h7) t5 = N(this, t5, i6, 0), o6 = !c3(t5) || t5 !== this._$AH && t5 !== b2, o6 && (this._$AH = t5);
    else {
      const e6 = t5;
      let n7, r7;
      for (t5 = h7[0], n7 = 0; n7 < h7.length - 1; n7++) r7 = N(this, e6[s7 + n7], i6, n7), r7 === b2 && (r7 = this._$AH[n7]), o6 ||= !c3(r7) || r7 !== this._$AH[n7], r7 === w ? t5 = w : t5 !== w && (t5 += (r7 ?? "") + h7[n7 + 1]), this._$AH[n7] = r7;
    }
    o6 && !e5 && this.j(t5);
  }
  j(t5) {
    t5 === w ? this.element.removeAttribute(this.name) : this.element.setAttribute(this.name, t5 ?? "");
  }
};
var R = class extends k {
  constructor() {
    super(...arguments), this.type = 3;
  }
  j(t5) {
    this.element[this.name] = t5 === w ? void 0 : t5;
  }
};
var H = class extends k {
  constructor() {
    super(...arguments), this.type = 4;
  }
  j(t5) {
    this.element.toggleAttribute(this.name, !!t5 && t5 !== w);
  }
};
var I = class extends k {
  constructor(t5, i6, s7, e5, h7) {
    super(t5, i6, s7, e5, h7), this.type = 5;
  }
  _$AI(t5, i6 = this) {
    if ((t5 = N(this, t5, i6, 0) ?? w) === b2) return;
    const s7 = this._$AH, e5 = t5 === w && s7 !== w || t5.capture !== s7.capture || t5.once !== s7.once || t5.passive !== s7.passive, h7 = t5 !== w && (s7 === w || e5);
    e5 && this.element.removeEventListener(this.name, this, s7), h7 && this.element.addEventListener(this.name, this, t5), this._$AH = t5;
  }
  handleEvent(t5) {
    "function" == typeof this._$AH ? this._$AH.call(this.options?.host ?? this.element, t5) : this._$AH.handleEvent(t5);
  }
};
var L = class {
  constructor(t5, i6, s7) {
    this.element = t5, this.type = 6, this._$AN = void 0, this._$AM = i6, this.options = s7;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AI(t5) {
    N(this, t5);
  }
};
var z = { P: e2, A: h2, C: o3, M: 1, L: P, R: S2, D: u2, V: N, I: M, H: k, N: H, U: I, B: R, F: L };
var W = t2.litHtmlPolyfillSupport;
W?.(V, M), (t2.litHtmlVersions ??= []).push("3.1.4");
var Z = (t5, i6, s7) => {
  const e5 = s7?.renderBefore ?? i6;
  let h7 = e5._$litPart$;
  if (void 0 === h7) {
    const t6 = s7?.renderBefore ?? null;
    e5._$litPart$ = h7 = new M(i6.insertBefore(l2(), t6), t6, void 0, s7 ?? {});
  }
  return h7._$AI(t5), h7;
};

// node_modules/lit-element/lit-element.js
var s3 = class extends g {
  constructor() {
    super(...arguments), this.renderOptions = { host: this }, this._$Do = void 0;
  }
  createRenderRoot() {
    const t5 = super.createRenderRoot();
    return this.renderOptions.renderBefore ??= t5.firstChild, t5;
  }
  update(t5) {
    const i6 = this.render();
    this.hasUpdated || (this.renderOptions.isConnected = this.isConnected), super.update(t5), this._$Do = Z(i6, this.renderRoot, this.renderOptions);
  }
  connectedCallback() {
    super.connectedCallback(), this._$Do?.setConnected(true);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this._$Do?.setConnected(false);
  }
  render() {
    return b2;
  }
};
s3._$litElement$ = true, s3["finalized", "finalized"] = true, globalThis.litElementHydrateSupport?.({ LitElement: s3 });
var r4 = globalThis.litElementPolyfillSupport;
r4?.({ LitElement: s3 });
(globalThis.litElementVersions ??= []).push("4.0.6");

// node_modules/lit-html/node/directive-helpers.js
var { I: t3 } = z;
var i3 = (o6) => null === o6 || "object" != typeof o6 && "function" != typeof o6;
var f3 = (o6) => void 0 === o6.strings;
var s4 = () => document.createComment("");
var r5 = (o6, i6, n7) => {
  const e5 = o6._$AA.parentNode, l3 = void 0 === i6 ? o6._$AB : i6._$AA;
  if (void 0 === n7) {
    const i7 = e5.insertBefore(s4(), l3), c7 = e5.insertBefore(s4(), l3);
    n7 = new t3(i7, c7, o6, o6.options);
  } else {
    const t5 = n7._$AB.nextSibling, i7 = n7._$AM, c7 = i7 !== o6;
    if (c7) {
      let t6;
      n7._$AQ?.(o6), n7._$AM = o6, void 0 !== n7._$AP && (t6 = o6._$AU) !== i7._$AU && n7._$AP(t6);
    }
    if (t5 !== l3 || c7) {
      let o7 = n7._$AA;
      for (; o7 !== t5; ) {
        const t6 = o7.nextSibling;
        e5.insertBefore(o7, l3), o7 = t6;
      }
    }
  }
  return n7;
};
var v2 = (o6, t5, i6 = o6) => (o6._$AI(t5, i6), o6);
var u3 = {};
var m3 = (o6, t5 = u3) => o6._$AH = t5;
var p3 = (o6) => o6._$AH;
var h3 = (o6) => {
  o6._$AP?.(false, true);
  let t5 = o6._$AA;
  const i6 = o6._$AB.nextSibling;
  for (; t5 !== i6; ) {
    const o7 = t5.nextSibling;
    t5.remove(), t5 = o7;
  }
};

// node_modules/lit-html/node/directive.js
var t4 = { ATTRIBUTE: 1, CHILD: 2, PROPERTY: 3, BOOLEAN_ATTRIBUTE: 4, EVENT: 5, ELEMENT: 6 };
var e3 = (t5) => (...e5) => ({ _$litDirective$: t5, values: e5 });
var i4 = class {
  constructor(t5) {
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AT(t5, e5, i6) {
    this._$Ct = t5, this._$AM = e5, this._$Ci = i6;
  }
  _$AS(t5, e5) {
    return this.update(t5, e5);
  }
  update(t5, e5) {
    return this.render(...e5);
  }
};

// node_modules/lit-html/node/async-directive.js
var s5 = (i6, t5) => {
  const e5 = i6._$AN;
  if (void 0 === e5) return false;
  for (const i7 of e5) i7._$AO?.(t5, false), s5(i7, t5);
  return true;
};
var o4 = (i6) => {
  let t5, e5;
  do {
    if (void 0 === (t5 = i6._$AM)) break;
    e5 = t5._$AN, e5.delete(i6), i6 = t5;
  } while (0 === e5?.size);
};
var r6 = (i6) => {
  for (let t5; t5 = i6._$AM; i6 = t5) {
    let e5 = t5._$AN;
    if (void 0 === e5) t5._$AN = e5 = /* @__PURE__ */ new Set();
    else if (e5.has(i6)) break;
    e5.add(i6), c4(t5);
  }
};
function h4(i6) {
  void 0 !== this._$AN ? (o4(this), this._$AM = i6, r6(this)) : this._$AM = i6;
}
function n4(i6, t5 = false, e5 = 0) {
  const r7 = this._$AH, h7 = this._$AN;
  if (void 0 !== h7 && 0 !== h7.size) if (t5) if (Array.isArray(r7)) for (let i7 = e5; i7 < r7.length; i7++) s5(r7[i7], false), o4(r7[i7]);
  else null != r7 && (s5(r7, false), o4(r7));
  else s5(this, i6);
}
var c4 = (i6) => {
  i6.type == t4.CHILD && (i6._$AP ??= n4, i6._$AQ ??= h4);
};
var f4 = class extends i4 {
  constructor() {
    super(...arguments), this._$AN = void 0;
  }
  _$AT(i6, t5, e5) {
    super._$AT(i6, t5, e5), r6(this), this.isConnected = i6._$AU;
  }
  _$AO(i6, t5 = true) {
    i6 !== this.isConnected && (this.isConnected = i6, i6 ? this.reconnected?.() : this.disconnected?.()), t5 && (s5(this, i6), o4(this));
  }
  setValue(t5) {
    if (f3(this._$Ct)) this._$Ct._$AI(t5, this);
    else {
      const i6 = [...this._$Ct._$AH];
      i6[this._$Ci] = t5, this._$Ct._$AI(i6, this, 0);
    }
  }
  disconnected() {
  }
  reconnected() {
  }
};

// node_modules/lit-html/node/directives/private-async-helpers.js
var s6 = class {
  constructor(t5) {
    this.Y = t5;
  }
  disconnect() {
    this.Y = void 0;
  }
  reconnect(t5) {
    this.Y = t5;
  }
  deref() {
    return this.Y;
  }
};
var i5 = class {
  constructor() {
    this.Z = void 0, this.q = void 0;
  }
  get() {
    return this.Z;
  }
  pause() {
    this.Z ??= new Promise((t5) => this.q = t5);
  }
  resume() {
    this.q?.(), this.Z = this.q = void 0;
  }
};

// node_modules/lit-html/node/directives/until.js
var n5 = (t5) => !i3(t5) && "function" == typeof t5.then;
var h5 = 1073741823;
var c5 = class extends f4 {
  constructor() {
    super(...arguments), this._$Cwt = h5, this._$Cbt = [], this._$CK = new s6(this), this._$CX = new i5();
  }
  render(...s7) {
    return s7.find((t5) => !n5(t5)) ?? b2;
  }
  update(s7, i6) {
    const e5 = this._$Cbt;
    let r7 = e5.length;
    this._$Cbt = i6;
    const o6 = this._$CK, c7 = this._$CX;
    this.isConnected || this.disconnected();
    for (let t5 = 0; t5 < i6.length && !(t5 > this._$Cwt); t5++) {
      const s8 = i6[t5];
      if (!n5(s8)) return this._$Cwt = t5, s8;
      t5 < r7 && s8 === e5[t5] || (this._$Cwt = h5, r7 = 0, Promise.resolve(s8).then(async (t6) => {
        for (; c7.get(); ) await c7.get();
        const i7 = o6.deref();
        if (void 0 !== i7) {
          const e6 = i7._$Cbt.indexOf(s8);
          e6 > -1 && e6 < i7._$Cwt && (i7._$Cwt = e6, i7.setValue(t6));
        }
      }));
    }
    return b2;
  }
  disconnected() {
    this._$CK.disconnect(), this._$CX.pause();
  }
  reconnected() {
    this._$CK.reconnect(this), this._$CX.resume();
  }
};
var m4 = e3(c5);

// src/js/spa.js
var toWords = (text) => {
  text = text.replace(/([A-Z])/g, " $1");
  return text.charAt(0).toUpperCase() + text.slice(1);
};
var kebabToPascal = (str) => {
  return str.split("-").map((word) => word.charAt(0).toUpperCase() + word.slice(1)).join("");
};
var toBoolean = (value) => {
  switch (typeof value) {
    case "boolean":
      return value;
    case "string":
      return ["true", "false"].includes(value.toLowerCase());
    case "number":
      return value !== 0;
    default:
      return false;
  }
};
var isWellFormedConfig = (config2) => {
  return typeof config2?.routes === "object";
};
var BOOLEAN_ATTRIBUTES = "hidden,required,disabled,readonly".split(",");
var debug = ["localhost", "127.0.0.1"].includes(location.hostname);
var PureSPAConfig = class {
  #rawConfig;
  #routes = {};
  #pages;
  #widgets;
  constructor(rawConfig) {
    this.#rawConfig = rawConfig;
    this.readConfig();
  }
  readConfig() {
    if (!isWellFormedConfig(this.#rawConfig))
      throw Error("PureSPA static config property mising or malformed.");
    const createRender = (path, tagName, widget, properties) => {
      return (routeData) => {
        properties = PureSPA.mapRouterVariables(tagName, properties, routeData);
        return PureSPA.createCustomTagLitHtml(tagName, {
          routeKey: path,
          widget,
          routeData,
          ...properties
        });
      };
    };
    const traverseRoutes = (configPart, basePath = "") => {
      for (const [route, options] of Object.entries(configPart)) {
        const path = basePath + route;
        const parentConfig = this.#routes[basePath];
        let widgetSettings = {};
        if (options.run && options.run.widgetSettings) {
          widgetSettings = options.run.widgetSettings;
        }
        let subRouteName = route.substring(1);
        let cleanSubRouteName = (subRouteName || "home").split("?")[0].toLowerCase();
        const hasPattern = subRouteName.indexOf(":") !== -1 || subRouteName.indexOf("?") !== -1 || subRouteName.indexOf("#") !== -1;
        if (hasPattern)
          cleanSubRouteName = cleanSubRouteName.replace(
            new RegExp("/|:|#", "g"),
            ""
          );
        let tagName = options.tagName;
        if (!tagName) {
          if (hasPattern) {
            if (!parentConfig) {
              if (!options.run)
                throw Error(
                  "Invalid routing config for subroute (" + basePath + ")"
                );
            } else {
              tagName = parentConfig.tagName;
              if (options.run && parentConfig.run !== options.run) {
                tagName = `${parentConfig.tagName}-${cleanSubRouteName}`.trim();
              }
            }
          } else {
            if (parentConfig) {
              tagName = `${parentConfig.tagName}-${subRouteName}`.trim();
            } else {
              tagName = `page-${cleanSubRouteName.toLowerCase().replace(new RegExp("/", "g"), "-")}`;
            }
          }
        }
        if (tagName && options.run) {
          customElements.define(tagName, options.run);
        }
        this.#routes[path] = {
          id: tagName.replace(/-/g, "_"),
          route: path,
          path: path.split("?")[0],
          parentRoute: basePath || void 0,
          isDetail: hasPattern,
          hidden: options.hidden ?? hasPattern,
          customPage: options.renderPage,
          renderPage: options.renderPage ?? createRender(path, tagName),
          widgetSettings,
          customWidget: options.renderWidget,
          renderWidget: options.renderWidget ?? createRender(path, tagName, true),
          name: options.name ?? toWords(subRouteName),
          tagName,
          definedBy: options.className ?? kebabToPascal(tagName),
          ...options
        };
        if (options.routes) {
          traverseRoutes(options.routes, path);
        }
      }
    };
    traverseRoutes(this.#rawConfig.routes);
    this.#pages = Object.values(this.#routes).map((options) => {
      return {
        ...options
      };
    }).filter((p4) => !p4.hidden);
  }
  /**
   * Returns all widgets (either custom ones defined in the config,
   * or page classes extending WidgetEnabledPage)
   */
  get widgets() {
    const createElement = (t5) => {
      try {
        return document.createElement(t5);
      } catch {
        return {};
      }
    };
    if (!this.#widgets)
      this.#widgets = Object.values(this.#routes).filter((options) => !options.isDetail).map((options) => {
        return {
          ...options,
          widget: options.customWidget || createElement(options.tagName) instanceof PureSPA.WidgetEnabledPage
        };
      }).filter((i6) => i6.widget);
    return this.#widgets;
  }
  get routes() {
    return this.#routes;
  }
  get pages() {
    return this.#pages;
  }
};
var RoutePage = class extends s3 {
  static get properties() {
    return {
      routeKey: { type: String },
      routeData: { type: Object }
    };
  }
  /**
   * Returns the current route's properties as defined in the configuration
   */
  get routeProperties() {
    return app.config.routes[this.routeKey];
  }
  // use light DOM
  createRenderRoot() {
    return this;
  }
};
var WidgetEnabledRoutePage = class extends RoutePage {
  static get properties() {
    return {
      ...RoutePage.properties,
      widget: {
        type: Boolean,
        attribute: true
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    const isFn = typeof this.constructor.getWidgetSettings === "function";
    const settings = isFn ? this.constructor.getWidgetSettings() : {};
    if (settings?.full) {
      this.setAttribute("full", "");
    }
    this.setAttribute("priority", settings.priority ?? 0);
  }
  render() {
    if (this.widget) return this.renderWidget();
    return this.renderPage();
  }
  /**
   * Renders a widget to display elsewhere
   */
  renderWidget() {
    throw new Error("renderWidget() must be implemented.");
  }
  /**
   * Gets the widget's settings
   */
  getWidgetSettings() {
    return {
      priority: 0,
      full: false
    };
  }
  /**
   * Renders the page as a route component
   */
  renderPage() {
    throw new Error("renderPage() must be implemented.");
  }
};
var PureSPAEnhancementRegistry = class {
  #list = /* @__PURE__ */ new Map();
  add(selector, enhancementFn) {
    this.#list.set(selector, enhancementFn);
  }
  run(element) {
    const length = this.#list.size;
    if (length === 0) return;
    for (const [selector, fn] of this.#list) {
      const enhance = (n7, s7, fn2) => {
        if (n7.hasAttribute("data-enhanced")) return;
        const result = fn2(n7);
        n7.setAttribute("data-enhanced", result?.toString() ?? "");
      };
      if (element.matches(selector)) enhance(element, selector, fn);
      const nodes = [...element.querySelectorAll(selector)];
      for (const node of nodes) enhance(node, selector, fn);
    }
  }
};
var PureSPA = class _PureSPA extends s3 {
  #config;
  #currentRoute;
  #routeMap = /* @__PURE__ */ new Map();
  #enhancers = new PureSPAEnhancementRegistry();
  constructor() {
    super();
    window.app = this;
  }
  connectedCallback() {
    super.connectedCallback();
    try {
      this.#config = new PureSPAConfig(this.constructor.config);
      this.#setGlobalAttributes();
      this.routerReady = this.#initializeRouting();
    } catch (ex) {
      console.error("Configuration error: ", ex.toString());
    }
  }
  /**
   * @returns { PureSPAEnhancementRegistry } enhancers registry
   */
  get enhancers() {
    return this.#enhancers;
  }
  /**
   * @returns {PureSPAConfig} configuration
   */
  get config() {
    return this.#config;
  }
  async #initializeRouting() {
    const me = this;
    const routes = {};
    for (const [path, options] of Object.entries(this.config.routes)) {
      routes[path] = options;
    }
    for (const r7 in routes) {
      this.#routeMap.set(new URLPattern(r7, window.location.origin), routes[r7]);
    }
    this.#routeMap.set(
      new URLPattern({
        pathname: "*",
        search: "*",
        baseURL: location.origin
      }),
      {
        route: "unknown",
        renderPage: this.notFoundPage
      }
    );
    window.navigation.addEventListener("navigate", (event2) => {
      if (event2.hashChange) return;
      const route = this.#getRoute(event2.destination.url);
      if (!route) return;
      document.documentElement.dataset.transition = this.getTransitionType();
      event2.intercept({
        async handler() {
          document.startViewTransition(() => {
            me.setRouteContent(route.data);
            window.scrollTo({
              top: 0,
              left: 0,
              behavior: "instant"
            });
          });
        }
      });
    });
    console.log(this.config);
    await this.beforeRouting();
  }
  /**
   * Gets the transition type for the view transition,
   * by comparing the current and future URLs.
   */
  getTransitionType() {
    const getDirection = (currentPath, newPath) => {
      if (newPath === currentPath) return;
      if (newPath.startsWith(currentPath)) return "forwards";
      else if (currentPath.startsWith(newPath)) return "backwards";
    };
    const cUrl = (u5) => {
      const url = new URL(u5);
      return url.pathname + url.hash;
    };
    return getDirection(cUrl(location.href), cUrl(event.destination.url));
  }
  /**
   * Gets the active route
   */
  get activeRoute() {
    return this.#currentRoute;
  }
  /**
   * Dispatch app-level event
   * @param {String} eventName
   * @param {Object} detail Optional details to pass along with event
   */
  fire(eventName, detail = {}) {
    this.dispatchEvent(
      new CustomEvent(eventName, {
        detail: detail || {}
      })
    );
  }
  /**
   * Listen for app-level event
   * @param {String} eventName
   * @param {Function} func
   */
  on(eventName, func) {
    this.addEventListener(eventName, func);
    return this;
  }
  /**
   * Stop listening to app-level event
   * @param {String} eventName
   * @param {Function} func
   */
  off(eventName, func) {
    this.removeEventListener(eventName, func);
    return this;
  }
  /**
   * Subclass this
   */
  async beforeRouting() {
    console.warn(
      "Subclass async beforeRouting() to load polyfills and do other async initialzation"
    );
  }
  #getRoute(urlString) {
    try {
      const url = new URL(urlString, location);
      const route = this.#findRoute(url);
      this.#setActiveRoute(route);
      try {
        return {
          route: route.pattern,
          data: typeof route.renderPage === "function" ? route.renderPage(route.patternResult) : route.renderPage,
          options: route
        };
      } finally {
        this.fireRouteComplete();
      }
    } catch (ex) {
      console.error("getRoute error: ", ex);
    }
  }
  #setActiveRoute(route) {
    if (this.#currentRoute) {
      this.fire("leaveroute", {
        route: this.#currentRoute.route
      });
    }
    this.#currentRoute = route;
    this.fire("activateroute", {
      route: this.#currentRoute
    });
    console.warn("Active Route: ", route.path ?? "INVALID");
  }
  #findRoute(url) {
    for (const [pattern, options] of this.#routeMap) {
      const patternResult = pattern.exec(url);
      if (patternResult)
        return {
          ...options,
          pattern,
          patternResult
        };
    }
    return;
  }
  fireRouteComplete() {
    this.fire("routecomplete", {
      route: this.#currentRoute
    });
  }
  async matchRouteWhenReady() {
    await this.routerReady;
    const url = window.location.href.split("?")[0];
    const route = this.#findRoute(url);
    this.#setActiveRoute(route);
    try {
      return typeof route.renderPage === "function" ? route.renderPage(route.patternResult) : route.renderPage;
    } finally {
      this.fireRouteComplete();
    }
  }
  matchRoute() {
    return m4(this.matchRouteWhenReady(), this.loadingPage);
  }
  /**
   * Subclass this to set the 404 page
   */
  get notFoundPage() {
    return x`<section class="block callout error">
      <h2>Not found</h2>
      <div class="center">
        <svg-icon icon="error" size="200px" color="#931620"></svg-icon>
      </div>
      <div>
        <h3>This page could not be found</h3>
      </div>
    </section>`;
  }
  updated() {
    super.updated();
    this.waitForFullRendering();
  }
  async waitForFullRendering() {
    await this.getUpdateComplete();
    this.enhancers.run(this);
  }
  firstUpdated() {
    const me = this;
    new MutationObserver((mutationsList) => {
      for (let mutation of mutationsList) {
        if (mutation.type === "childList") {
          for (const node of mutation.addedNodes) {
            if (node.nodeType === Node.ELEMENT_NODE) me.enhancers.run(node);
          }
        }
      }
    }).observe(this, { childList: true, subtree: true });
  }
  /**
   * Sublass this to set the loading page html.
   */
  get loadingPage() {
    return x` <div class="fill skeleton">
      <app-shimmer class="title"></app-shimmer>
      <app-shimmer class="image"></app-shimmer>
      <app-shimmer></app-shimmer>
    </div>`;
  }
  goBack(fallback) {
    if (navigation.canGoBack) {
      history.back();
      return;
    }
    history.replaceState({}, "", fallback);
  }
  /**
   * Called from router
   * @param {Object} content - route data to render
   */
  setRouteContent(content) {
    this.content = content;
    this.requestUpdate();
    requestAnimationFrame(this.routeComplete.bind(this));
  }
  /**
   * Called when a route change is completed.
   */
  routeComplete() {
  }
  /**
   * Called on first page request.
   * On route changes (via router), setRouteContent()
   * is called from router, which forces re-render.
   */
  getRouteContent() {
    const route = this.matchRoute();
    this.content = new Promise((resolve) => {
      this.readyToRoute().then(() => {
        resolve(route);
        requestAnimationFrame(this.routeComplete.bind(this));
      });
    });
  }
  render() {
    if (!this.content) this.getRouteContent();
    return x`${m4(this.content, this.loadingPage)}`;
  }
  // PureApp is a Light DOM Web Component
  createRenderRoot() {
    return this;
  }
  // Lit properties
  static get properties() {
    return {
      config: { type: Object }
    };
  }
  /**
   * Subclass this for any initialization stuff that needs to run before the first route is rendered.
   * @returns {Boolean}
   */
  async readyToRoute() {
    return true;
  }
  // set <html> element attributes
  #setGlobalAttributes() {
    const htm = document.documentElement;
    if (debug) htm.setAttribute("debug", "");
  }
  /**
   * @returns {WidgetEnabledPage} Class that can be extended from in Routes that also have a Widget.
   */
  static get WidgetEnabledPage() {
    return WidgetEnabledRoutePage;
  }
  /**
   * @returns {RoutePage} Class that can be extended from in Routes.
   */
  static get Page() {
    return RoutePage;
  }
  /**
   * Returns Lit Safe html to render any Web Component
   * @param {String} tagName
   * @param {Object} keyValuePairs
   * @returns { html }
   */
  static createCustomTagLitHtml(tagName, keyValuePairs) {
    const body = `return html\`<${tagName} ${_PureSPA.generateAttributeString(
      keyValuePairs
    )}></${tagName}>\``;
    const renderCustomElement = Function.apply(null, [
      "html, css, field",
      body
    ]);
    return x`${renderCustomElement(x, i, keyValuePairs)}`;
  }
  /**
   * Generates an attribute string dynamically.
   * @param {Object} keyValuePairs
   * @returns { String } html attribute string
   */
  static generateAttributeString(keyValuePairs) {
    const body = [];
    Object.entries(keyValuePairs).forEach(([key, value]) => {
      const type = typeof value;
      switch (key) {
        case "label":
          body.push(`data-label="${value}" `);
          break;
        case "subType":
          body.push(`type="${value}" `);
          break;
        default:
          if (["boolean"].includes(type) || BOOLEAN_ATTRIBUTES.includes(key)) {
            body.push((toBoolean(value) ? key : "") + " ");
          } else if (["string", "number"].includes(type)) {
            body.push(`${key}="${value}" `);
          } else body.push(`.${key}=\${field['${key}']} `);
          break;
      }
    });
    return body.join("");
  }
  /**
   * Maps routing UrlPattern variables for Lit element dynamic rendering
   * @param {String} tagName
   * @param {Object} properties
   * @param {Object} routeData
   * @returns
   */
  static mapRouterVariables(tagName, properties, routeData) {
    properties = { ...properties ?? {} };
    const element = window.customElements.get(tagName);
    if (element && element.properties) {
      for (const [propertyName, options] of Object.entries(
        element.properties
      )) {
        if (options.routeOrigin)
          properties[propertyName] = routeData[options.routeOrigin]?.groups[propertyName];
      }
    }
    return properties;
  }
};

// src/js/pages/page-about.js
var PageAbout = class extends PureSPA.WidgetEnabledPage {
  renderPage() {
    return x`

    <div>
    <input
      name="test"
      placeholder="Test input..."
      type="text"
      data-label="Test"
      maxlength="20"
    />
    </div>

    `;
  }
  renderWidget() {
    return x`About (widget)`;
  }
};

// node_modules/lit-html/node/directives/repeat.js
var u4 = (e5, s7, t5) => {
  const r7 = /* @__PURE__ */ new Map();
  for (let l3 = s7; l3 <= t5; l3++) r7.set(e5[l3], l3);
  return r7;
};
var c6 = e3(class extends i4 {
  constructor(e5) {
    if (super(e5), e5.type !== t4.CHILD) throw Error("repeat() can only be used in text expressions");
  }
  dt(e5, s7, t5) {
    let r7;
    void 0 === t5 ? t5 = s7 : void 0 !== s7 && (r7 = s7);
    const l3 = [], o6 = [];
    let i6 = 0;
    for (const s8 of e5) l3[i6] = r7 ? r7(s8, i6) : i6, o6[i6] = t5(s8, i6), i6++;
    return { values: o6, keys: l3 };
  }
  render(e5, s7, t5) {
    return this.dt(e5, s7, t5).values;
  }
  update(s7, [t5, r7, c7]) {
    const d3 = p3(s7), { values: p4, keys: a3 } = this.dt(t5, r7, c7);
    if (!Array.isArray(d3)) return this.ut = a3, p4;
    const h7 = this.ut ??= [], v3 = [];
    let m5, y3, x2 = 0, j = d3.length - 1, k2 = 0, w2 = p4.length - 1;
    for (; x2 <= j && k2 <= w2; ) if (null === d3[x2]) x2++;
    else if (null === d3[j]) j--;
    else if (h7[x2] === a3[k2]) v3[k2] = v2(d3[x2], p4[k2]), x2++, k2++;
    else if (h7[j] === a3[w2]) v3[w2] = v2(d3[j], p4[w2]), j--, w2--;
    else if (h7[x2] === a3[w2]) v3[w2] = v2(d3[x2], p4[w2]), r5(s7, v3[w2 + 1], d3[x2]), x2++, w2--;
    else if (h7[j] === a3[k2]) v3[k2] = v2(d3[j], p4[k2]), r5(s7, d3[x2], d3[j]), j--, k2++;
    else if (void 0 === m5 && (m5 = u4(a3, k2, w2), y3 = u4(h7, x2, j)), m5.has(h7[x2])) if (m5.has(h7[j])) {
      const e5 = y3.get(a3[k2]), t6 = void 0 !== e5 ? d3[e5] : null;
      if (null === t6) {
        const e6 = r5(s7, d3[x2]);
        v2(e6, p4[k2]), v3[k2] = e6;
      } else v3[k2] = v2(t6, p4[k2]), r5(s7, d3[x2], t6), d3[e5] = null;
      k2++;
    } else h3(d3[j]), j--;
    else h3(d3[x2]), x2++;
    for (; k2 <= w2; ) {
      const e5 = r5(s7, v3[w2 + 1]);
      v2(e5, p4[k2]), v3[k2++] = e5;
    }
    for (; x2 <= j; ) {
      const e5 = d3[x2++];
      null !== e5 && h3(e5);
    }
    return this.ut = a3, m3(s7, v3), b2;
  }
});

// src/js/pages/page-home.js
var PageHome = class extends PureSPA.Page {
  render() {
    return x`

      Home
    `;
  }
};

// src/js/pages/page-terms.js
var PageTerms = class extends PureSPA.Page {
  render() {
    return x`<div class="tiles masonry">
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>1: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>2: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>3: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>4: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>5: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>6: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>7: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>8: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>9: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>10: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>11: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>12: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>13: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>14: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>15: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>16: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>17: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>18: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>19: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>20: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>21: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>22: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>23: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>24: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>25: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>26: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
      <div class="item project">
      <div class="content">
        <div class="title">
          <h3>27: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>28: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>29: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>30: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>31: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>32: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>33: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>34: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>35: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>36: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>37: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>38: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>39: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>40: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>41: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>42: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>43: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>44: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>45: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>46: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>47: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>48: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>49: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>50: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>51: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>52: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>53: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>54: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>55: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>56: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>57: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>58: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>59: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>60: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>61: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>62: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>63: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>64: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>65: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>66: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>67: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>68: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>69: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>70: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>71: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>72: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>73: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>74: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>75: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>76: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>77: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>78: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>79: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>80: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>81: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>82: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog5.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>83: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>84: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>85: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>86: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>87: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>88: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>89: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>90: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>91: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>92: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>93: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis</p>
        </div>
      </div>
    </div>
    <div class="item blog">
      <div class="content">
        <div class="title">
          <h3>94: Blog Post</h3>
        </div>
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. </p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>95: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog9.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>96: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog10.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam,</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>97: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog1.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel .</p>
        </div>
      </div>
    </div>
    <div class="item photo">
      <div class="content">
        <div class="title">
          <h3>98: Photo</h3>
        </div>
        <img class="photothumb" src="https://assets.codepen.io/881020/dog2.jpg">
        <div class="desc">
          <p>Lorem ipsum dolor sit amet, conse</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>99: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog3.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed dictum non orci ut dignissim. Fusce fermentum felis aliquam, mattis nibh ut, faucibus leo. Sed lectus libero, volutpat at eros quis, venenatis tempus neque. Nulla vel faucibus orci, nec convallis ligula. Quisque maximus gravida orci, in lacinia mauris pretium nec. Sed et enim bibendum, fermentum tellus eu, eleifend ex. Aliquam lectus magna, sollicitudin vitae placerat ac, semper ut risus. Nunc vestibulum lacus et nulla volutpat auctor.</p>
        </div>
      </div>
    </div>
    <div class="item project">
      <div class="content">
        <div class="title">
          <h3>100: Project</h3>
        </div>
        <div class="desc">
          <img src="https://assets.codepen.io/881020/dog4.jpg">
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce facilisis fringilla laoreet. Mauris mattis enim ut felis consectetur, vitae lacinia enim auctor. Aenean vitae fermentum odio. Lorem, nec convallis ligula. Quisque maximus </p>
        </div>
      </div>
    </div>
  </div>`;
  }
};

// src/js/app.config.js
var config = {
  routes: {
    "/": {
      name: "Home",
      run: PageHome
    },
    "/about": {
      run: PageAbout
    },
    "/terms": {
      run: PageTerms
    }
  }
};

// src/js/common.js
var ctlNr = 1e3;
function getUniqueName(prefix = "df", radix = 16) {
  return `${prefix}${(ctlNr++).toString(radix)}`;
}
function parseHTML(html) {
  return new DOMParser().parseFromString(html, "text/html").body.childNodes;
}
function throttle(fn, timeoutMs = 100) {
  let handle;
  return function executedFunction(...args) {
    const fire = () => {
      clearTimeout(handle);
      fn(...args);
    };
    clearTimeout(handle);
    handle = setTimeout(fire, timeoutMs);
  };
}
function enQueue(fn) {
  setTimeout(fn, 0);
}
function isUrl(str) {
  try {
    if (typeof str !== "string") return false;
    if (str.indexOf("\n") !== -1 || str.indexOf(" ") !== -1) return false;
    if (str.startsWith("#/")) return false;
    const newUrl = new URL(str, window.location.origin);
    return newUrl.protocol === "http:" || newUrl.protocol === "https:";
  } catch {
    return false;
  }
}
function openCenteredWindow(url, width, height) {
  const left = window.screen.width / 2 - width / 2;
  const top = window.screen.height / 2 - height / 2;
  return window.open(
    url,
    "",
    `toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=${width}, height=${height}, top=${top}, left=${left}`
  );
}
var inputTemplate = (
  /*html*/
  `
<label>
  <span data-label></span>
  <span class="placeholder"></span>
</label>`
);
function enhanceInputWithLabel(input) {
  const labelText = input.getAttribute("data-label") ?? "";
  if (labelText.length) {
    const label = parseHTML(inputTemplate)[0];
    const type = input.getAttribute("type") || "text";
    input.insertAdjacentElement("beforebegin", label);
    label.querySelector(".placeholder").replaceWith(input);
    label.querySelector("span[data-label]").textContent = labelText;
    input.removeAttribute("data-label");
    input.setAttribute("type", type);
  }
  const icon = input.getAttribute("data-icon") || "";
  if (icon) {
    const iconColor = input.getAttribute("data-icon-color") || "";
    const iconSize = input.getAttribute("data-icon-size") || "";
    const iconHtml = (
      /*html*/
      `<svg-icon icon="${icon}" color="${iconColor}" size="${iconSize}"></svg-icon>`
    );
    input.insertAdjacentElement("afterend", parseHTML(iconHtml)[0]);
  }
}
var uniqueNavId;
function enhanceNavDropdownButton(nav) {
  const button = nav.querySelector("button");
  if (button.textContent.trim().length === 0) {
    const span = document.createElement("span");
    span.innerHTML = "&nbsp;";
    span.setAttribute("data-label", "");
    span.setAttribute("hidden", "");
    button.appendChild(span);
  }
  const menu = nav.querySelector("menu");
  menu.setAttribute("role", "menu");
  menu.setAttribute("hidden", "");
  uniqueNavId = getUniqueName("nav");
  nav.setAttribute("aria-controls", uniqueNavId);
  nav.setAttribute("aria-haspopup", "true");
  nav.setAttribute("aria-expanded", "false");
  menu.setAttribute("id", uniqueNavId);
  [...menu.children].forEach((li) => {
    li.setAttribute("role", "menuitem");
  });
  button.addEventListener("click", () => {
    const hidden = menu.hasAttribute("hidden");
    if (hidden) {
      menu.removeAttribute("hidden");
      setTimeout(() => {
        document.addEventListener(
          "click",
          (e5) => {
            if (!nav.contains(e5.target)) button.click();
          },
          {
            once: true
          }
        );
      }, 100);
    } else menu.setAttribute("hidden", "");
  });
  return "nav";
}
function enhanceMasonryGrid(element) {
  element.style.setProperty("grid-auto-rows", "20px");
  createStyleSheet(
    /*css*/
    `
    .masonry {
      opacity: 0;
    }

    .masonry-applied {
      opacity: 1;
      transition: opacity .2s ease
    }
    `
  );
  const resizeGridItem = (item) => {
    const rowHeight = parseInt(
      window.getComputedStyle(element).getPropertyValue("grid-auto-rows")
    );
    const rowGap = parseInt(
      window.getComputedStyle(element).getPropertyValue("grid-row-gap")
    );
    const rowSpan = Math.ceil(
      (item.querySelector(".content").getBoundingClientRect().height + rowGap) / (rowHeight + rowGap)
    );
    item.style.gridRowEnd = "span " + rowSpan;
  };
  const resizeAllGridItems = () => {
    try {
      element.classList.remove("masonry-applied");
      for (const item of element.children) resizeGridItem(item);
    } finally {
      element.classList.add("masonry-applied");
    }
  };
  window.addEventListener("resize", throttle(resizeAllGridItems, 100));
  waitForImages(element).then(resizeAllGridItems);
  return "masonry";
}
function waitForImages(container) {
  const imgElements = container.querySelectorAll("img");
  const imgPromises = Array.from(imgElements).map((img) => {
    return new Promise((resolve, reject) => {
      const imgSrc = img.src;
      const image = new Image();
      image.onload = () => resolve(imgSrc);
      image.onerror = (error) => reject(error);
      image.src = imgSrc;
    });
  });
  return Promise.all(imgPromises);
}
function createStyleSheet(cssText) {
  try {
    let css = new CSSStyleSheet();
    css.replaceSync(cssText);
    document.querySelector("head").appendChild(css);
  } catch {
    let id = generateHash(cssText);
    let style = document.getElementById(id);
    if (!style) {
      style = document.createElement("style");
      style.id = id;
      style.textContent = cssText;
      document.querySelector("head").appendChild(style);
    } else {
      console.log(id, "already added ...");
    }
    return {
      cssText
    };
  }
}
function generateHash(str, seed = 0) {
  let h1 = 3735928559 ^ seed, h22 = 1103547991 ^ seed;
  for (let i6 = 0, ch; i6 < str.length; i6++) {
    ch = str.charCodeAt(i6);
    h1 = Math.imul(h1 ^ ch, 2654435761);
    h22 = Math.imul(h22 ^ ch, 1597334677);
  }
  h1 = Math.imul(h1 ^ h1 >>> 16, 2246822507) ^ Math.imul(h22 ^ h22 >>> 13, 3266489909);
  h22 = Math.imul(h22 ^ h22 >>> 16, 2246822507) ^ Math.imul(h1 ^ h1 >>> 13, 3266489909);
  return 4294967296 * (2097151 & h22) + (h1 >>> 0);
}

// src/js/autocomplete.js
var AutoComplete = class _AutoComplete {
  cssClasses = {
    result: "ac-suggestion",
    item: "ac-itm"
  };
  constructor(parent, textInput, settings) {
    this.settings = {
      emptyResultsText: "No results",
      ...settings
    };
    this.container = parent;
    this.input = textInput;
    this.input.setAttribute("autocomplete", "off");
    this.categories = settings.categories || {};
    enQueue(this.attach.bind(this));
  }
  /**
   * Connector logic to call on @focus events.
   * Lit example:
   * <input type="search" @focus=${(e) => {AutoComplete.connect(e, this.autoComplete); }} />
   *
   * @param {*} event focus event
   * @param {*} options AutoComplete options
   */
  static connect(event2, options) {
    const input = event2.target;
    if (!input._autoComplete) {
      if (!options?.categories) throw Error("Missing autocomplete settings");
      input._autoComplete = new _AutoComplete(input.parentNode, input, options);
      if (event2.type === "focus") {
        setTimeout(() => {
          input._autoComplete.focusHandler(event2);
        }, 100);
      }
    }
  }
  on(a3, b3) {
    this.input.addEventListener(a3, b3);
    return this;
  }
  attach() {
    this.resultsDiv = document.createElement("div");
    this.resultsDiv.title = "";
    this.resultsDiv.classList.add(this.cssClasses.result);
    this.resultsDiv.style.width = this.container.offsetWidth;
    this.resultsDiv.addEventListener("mousedown", this.resultClick.bind(this));
    this.container.classList.add("ac-container");
    this.input.classList.add("ac-input");
    const inputStyle = getComputedStyle(this.input);
    this.container.style.setProperty("--ac-bg-default", inputStyle.backgroundColor);
    this.container.style.setProperty("--ac-color-default", inputStyle.color);
    const acc = getComputedStyle(this.input).accentColor;
    if (acc !== "auto")
      this.container.style.setProperty("--ac-accent-color", acc);
    (this.container?.shadowRoot ?? this.container).appendChild(this.resultsDiv);
    this.clear();
    this.on(
      "input",
      throttle(
        this.inputHandler.bind(this),
        this.settings.throttleInputMs ?? 300
      )
    ).on("focus", this.focusHandler.bind(this)).on("focusout", this.blurHandler.bind(this)).on("keyup", this.keyUpHandler.bind(this)).on("keydown", this.keyDownHandler.bind(this));
  }
  controller() {
    let c7 = this.internalController();
    if (typeof this.settings.controller === "function")
      c7 = this.settings.controller(this) ?? c7;
    return c7;
  }
  internalController() {
    return {
      show: this.show.bind(this),
      hide: this.hide.bind(this),
      empty: () => {
      }
    };
  }
  moveResult(add) {
    this.controller().show();
    let length = this.acItems.length;
    this.rowIndex = this.rowIndex + add;
    if (this.rowIndex < 0) {
      this.rowIndex = length - 1;
    } else if (this.rowIndex > length - 1) {
      this.rowIndex = 0;
    }
    for (const r7 of this.acItems) {
      r7.classList.remove("selected");
    }
    let div = this.getSelectedDiv();
    if (div) {
      div.classList.add("selected");
      div.scrollIntoView({
        behavior: "smooth",
        block: "end",
        inline: "nearest"
      });
    } else {
      this.focusHandler({
        target: this.input
      });
    }
  }
  getSelectedDiv() {
    return this.resultsDiv.querySelector(`div:nth-child(${this.rowIndex + 1})`);
  }
  // execute action
  selectResult(div) {
    div = div || this.getSelectedDiv();
    if (div) {
      let index = parseInt(div.getAttribute("data-index"));
      this.resultClicked = true;
      let result = this.results[index];
      let handlingCategory = this.categories[result.category] ?? {};
      handlingCategory.action = handlingCategory.action ?? this.setText.bind(this);
      if (handlingCategory.newTab) {
        this.tabWindow = openCenteredWindow("about:blank");
      }
      let options = {
        ...result,
        search: this.input.value
      };
      div.classList.add("active");
      setTimeout(() => {
        this.controller().hide();
        if (options.action) {
          options.action(options);
        } else {
          handlingCategory.action(options);
          if (handlingCategory.newTab) {
            if (options.url) {
              this.tabWindow.location.href = options.url;
            } else {
              this.tabWindow.close();
            }
          }
        }
        var event2 = new Event("change", { bubbles: true });
        this.input.dispatchEvent(event2);
        this.clear();
        const ev = new Event("result-selected");
        ev.detail = options;
        this.input.dispatchEvent(ev);
      }, 0);
    }
  }
  setText(options) {
    this.input.value = options.text;
    this.controller().hide();
  }
  resultClick(event2) {
    this.selectResult(event2.target.closest(`.${this.cssClasses.item}`));
  }
  blurHandler() {
    setTimeout(() => {
      if (!this.resultClicked) this.clear();
      this.resultClicked = false;
    }, 100);
  }
  clear() {
    if (this.settings.debug) return;
    if (!this.resultsDiv) return;
    this.resultsDiv.innerHTML = "";
    this.controller().hide();
  }
  show() {
    const rect = this.input.getBoundingClientRect();
    this.settings.direction = rect.top + rect.height + 300 > window.innerHeight ? "up" : "down";
    this.container.setAttribute("data-direction", this.settings.direction);
    if (!this.container.classList.contains("ac-active")) {
      this.resultsDiv.style.width = `${rect.width}px`;
      this.acItems = this.resultsDiv.querySelectorAll(".ac-itm");
      if (this.settings.direction === "up") {
        this.resultsDiv.style.top = "unset";
        this.resultsDiv.style.bottom = `${rect.height}px`;
        this.rowIndex = this.acItems.length;
      } else {
        this.resultsDiv.style.bottom = "unset";
        this.resultsDiv.style.top = `${rect.height}px`;
        this.rowIndex = -1;
      }
      this.resultsDiv.style.maxWidth = "unset";
      this.container.classList.toggle("ac-active", true);
    }
  }
  hide() {
    this.container.classList.toggle("ac-active", false);
  }
  empty() {
    this.resultsDiv.innerHTML = `<div class="ac-empty">${this.settings.emptyResultsText}</div>`;
    this.controller().show();
  }
  inputHandler(e5) {
    this.clear();
    let options = {
      search: e5.target.value,
      categories: this.categories
    };
    this.container.classList.add("search-running");
    this.getItems(options, e5).then((r7) => {
      this.clear();
      this.resultsHandler(r7, options);
      this.container.classList.remove("search-running");
    });
  }
  keyDownHandler(e5) {
    switch (e5.key) {
      case "Enter":
        e5.stopPropagation();
        e5.preventDefault();
        break;
      case "ArrowDown":
        enQueue(this.moveResult(1));
        break;
      case "ArrowUp":
        enQueue(this.moveResult(-1));
        break;
    }
  }
  keyUpHandler(e5) {
    switch (e5.key) {
      case "Escape":
        this.hide();
        break;
      case "Enter":
        if (this.getSelectedDiv()) {
          this.container.preventEnter = true;
          e5.stopPropagation();
          e5.preventDefault();
          this.selectResult();
          setTimeout(() => {
            this.container.preventEnter = false;
          }, 10);
        }
        break;
      default:
        break;
    }
  }
  focusHandler(e5) {
    this.clear();
    let value = e5.target.value;
    this.suggest(value, e5);
  }
  /**
   * Shows suggestion box
   * @param {string} value - String to suggest results for
   */
  suggest(value, e5) {
    this.input.focus();
    const options = {
      suggest: true,
      search: value || "",
      categories: this.categories
    };
    this.getItems(options, e5).then((r7) => {
      this.input.dispatchEvent(
        new CustomEvent("show-results", {
          detail: {
            results: r7
          }
        })
      );
      this.resultsHandler(r7, options);
    });
  }
  resultsHandler(r7, options) {
    this.results = r7;
    this.rowIndex = -1;
    let index = 0;
    const singleItemTemplate = (catHandler, i6) => {
      return (
        /*html*/
        `
      <div title="${i6.tooltip || ""}" data-index="${index}" class="${`${this.cssClasses.item} cat-${i6.category} ${i6.class ?? ""}`.trim()}">
        ${this.handleImageOrIcon(i6)}
        <span class="text">${this.formatResultItem(
          i6,
          options,
          catHandler
        )}</span>
        <span class="category">${i6.category || ""}</span>
      </div>`
      );
    };
    r7.forEach((i6) => {
      let catHandler = options.categories[i6.category] || {};
      if (i6.element) {
        this.resultsDiv.appendChild(i6.element);
      } else {
        i6 = typeof i6 === "string" ? { text: i6 } : i6;
        this.resultsDiv.appendChild(
          parseHTML(singleItemTemplate(catHandler, i6))[0]
        );
      }
      index++;
    });
    if (r7.length) {
      this.controller().show();
    } else if (options.search.length) this.controller().empty();
  }
  handleImageOrIcon(i6) {
    if (i6.image) {
      return (
        /*html*/
        `<img src="${i6.image}"/>`
      );
    }
    return (
      /*html*/
      `<svg-icon icon="${i6.icon}"></svg-icon>`
    );
  }
  formatResultItem(item, options, catHandler) {
    const i6 = typeof item === "string" ? { text: item } : item;
    let result = i6.text;
    if (options.search) {
      result = result.replace("%search%", options.search);
      i6.description = i6.description?.replace("%search%", options.search);
    }
    result = this.highlight(result, options.search);
    if (i6.description) {
      result = `<div>${result}</div><small>${i6.description}</small>`;
    }
    if (catHandler.format) {
      result = catHandler.format({
        item: i6,
        result,
        options
      });
    }
    return result;
  }
  highlight(str, find) {
    var reg = new RegExp("(" + find + ")", "gi");
    return str.replace(reg, '<span class="txt-hl">$1</span>');
  }
  async getItems(options, e5) {
    const prop = this.settings.map;
    const normalizeItem = (i6) => {
      if (typeof i6 === "string") i6 = { text: i6 };
      return i6;
    };
    const map = (list) => {
      if (!prop) {
        return list.map((i6) => {
          return normalizeItem(i6);
        });
      }
      return list.map((i6) => {
        return { text: i6[prop] };
      });
    };
    const max = (list) => {
      if (this.settings.max && this.settings.max > 0) {
        list.length = this.settings.max;
      }
      return list;
    };
    return new Promise((resolve) => {
      if (isUrl(this.items)) {
        if (this.settings.minlength > 0) {
          if (!options.search || options.search.length < this.settings.minlength) {
            resolve([]);
            return;
          }
        }
        let url = this.formatSearch(this.items, options);
        fetch(url).then((x2) => {
          if (x2.status === 200) {
            x2.json().then((items) => {
              items = map(items);
              resolve(
                max(
                  items.filter((i6) => {
                    return this.isMatch(options, i6);
                  })
                )
              );
            });
            return;
          }
          throw Error(`HTTP error ${x2.status} - ${url}`);
        });
      } else if (Array.isArray(this.items)) {
        let simple = true;
        this.items = this.items.map((i6) => {
          if (typeof i6 === "string") {
            return { text: i6 };
          }
          simple = false;
          return i6;
        });
        if (simple) {
          this.container.classList.add("simple");
        }
        resolve(max(map(this.items)));
      } else if (typeof this.items === "function") {
        options.control = this.container;
        let ar = Promise.resolve(this.items(options, e5));
        ar.then((ar2) => {
          ar2 = ar2.map((i6) => {
            return normalizeItem(i6);
          });
          ar2 = map(ar2);
          resolve(ar2);
        });
      } else {
        return resolve(Promise.resolve(this.items.apply(this, options)));
      }
    });
  }
  async items(options) {
    let arr = [];
    options.results = [];
    for (var c7 in options.categories) {
      let catHandler = options.categories[c7];
      catHandler.trigger = catHandler.trigger ?? (() => {
        return true;
      });
      options.results = arr;
      if (catHandler.trigger(options)) {
        let catResults = [];
        try {
          catResults = await catHandler.getItems(options);
        } catch (ex) {
          console.warn(`Error loading items for omniBox category '${c7}'.`, ex);
        }
        arr = arr.concat(
          catResults.map((i6) => {
            i6.category = c7;
            return i6;
          })
        );
      }
    }
    return arr;
  }
  formatSearch(url, options) {
    if (url.indexOf("%search%")) {
      return url.replace("%search%", options.search || "");
    }
    return url + "?" + this.createQueryParam(options);
  }
  createQueryParam(options) {
    let suggest = options.suggest ? "&suggest=true" : "";
    return `q=${options.text}${suggest}`;
  }
  isMatch(options, i6) {
    if (i6.text?.indexOf("%search%") >= 0) return true;
    return options.search ? i6.text?.toLowerCase().indexOf(options.search.toLowerCase()) >= 0 : options.suggest;
  }
  static textFilter(options, propertyName) {
    return function(i6) {
      if (!options.search) return true;
      if (i6.hidden) return false;
      const prop = propertyName ? i6[propertyName] : i6;
      const isMatch = prop.match(new RegExp(options.search, "gi"));
      if (isMatch) return isMatch;
      if (i6.config?.tags) {
        return i6.config.tags.some((tag) => {
          return tag.match(new RegExp(options.search, "gi"));
        });
      }
    };
  }
};

// node_modules/lit-html/node/directives/ref.js
var e4 = () => new h6();
var h6 = class {
};
var o5 = /* @__PURE__ */ new WeakMap();
var n6 = e3(class extends f4 {
  render(i6) {
    return w;
  }
  update(i6, [s7]) {
    const e5 = s7 !== this.Y;
    return e5 && void 0 !== this.Y && this.rt(void 0), (e5 || this.lt !== this.ct) && (this.Y = s7, this.ht = i6.options?.host, this.rt(this.ct = i6.element)), w;
  }
  rt(t5) {
    if (this.isConnected || (t5 = void 0), "function" == typeof this.Y) {
      const i6 = this.ht ?? globalThis;
      let s7 = o5.get(i6);
      void 0 === s7 && (s7 = /* @__PURE__ */ new WeakMap(), o5.set(i6, s7)), void 0 !== s7.get(this.Y) && this.Y.call(this.ht, void 0), s7.set(this.Y, t5), void 0 !== t5 && this.Y.call(this.ht, t5);
    } else this.Y.value = t5;
  }
  get lt() {
    return "function" == typeof this.Y ? o5.get(this.ht ?? globalThis)?.get(this.Y) : this.Y?.value;
  }
  disconnected() {
    this.lt === this.ct && this.rt(void 0);
  }
  reconnected() {
    this.rt(this.ct);
  }
});

// src/js/polyfills/polyfillsLoader.js
async function LoadPolyfillsIfNeeded() {
  if (!(globalThis && "URLPattern" in globalThis)) {
    console.log("URLPattern polyfill is needed...");
    const path = "/assets/js/polyfills/urlpattern-polyfill.js";
    await import(path);
  }
  if (!(globalThis && "navigation" in globalThis)) {
    console.log("Navigation polyfill is needed...");
    const path = "/assets/js/polyfills/navigation-polyfill.js";
    await import(path);
  }
  if (!(document && "startViewTransition" in document)) {
    console.log("View-transition polyfill is needed...");
    const path = "/assets/js/polyfills/view-transition-polyfill.js";
    await import(path);
  }
}
var polyfillsLoaded = LoadPolyfillsIfNeeded();

// src/js/svg-icon.js
customElements.define(
  "svg-icon",
  /**
   * Renders SVG icon using SVG sprites defined in /assets/img/icons.svg
   */
  class SVGIcon extends s3 {
    static get styles() {
      return [
        i`
          :host(.rounded) {
            pointer-events: none;
            border-radius: 50%;
            aspect-ratio: 1/1;
            padding: 0.3rem 0.8rem 0 0.2rem;
          }

          @keyframes rotation {
            from {
              transform: rotate(0deg);
            }
            to {
              transform: rotate(360deg);
            }
          }

          svg {
            pointer-events: none;
            fill: var(--icon-fill-color);
            stroke: var(--icon-stroke-color);
            display: block;
            transition: fill var(--transition-duration) ease-in-out;
          }
          .icon {
            width: var(--icon-size, 32px);
            height: var(--icon-size, 32px);
          }
          :host([spinner]) .icon {
            animation: rotation 1s linear infinite;
          }
        `
      ];
    }
    static get properties() {
      return {
        icon: {
          attribute: true
        },
        color: {
          attribute: true
        },
        stroke: {
          type: Boolean,
          attribute: true
        },
        size: {
          attribute: true
        },
        spinner: { type: Boolean, reflect: true, attribute: true }
      };
    }
    render() {
      let style = "";
      if (this.size) style += ";--icon-size: " + this.size;
      if (this.color) style += ";--icon-fill-color: " + this.color;
      if (this.stroke) style += ";--icon-stroke-color: " + this.color;
      return x`<svg style=${style} class="icon" xmlns="http://www.w3.org/2000/svg">
        <use href="/assets/img/icons.svg#${this.icon}" />
      </svg>`;
    }
  }
);

// src/js/app.js
customElements.define(
  "my-app",
  class MyApp extends PureSPA {
    #h1 = e4();
    #aside = e4();
    /**
     * Set app.config structure
     */
    static get config() {
      return config;
    }
    constructor() {
      super();
      this.enhancers.add("[data-label]", enhanceInputWithLabel);
      this.enhancers.add("nav[data-dropdown]", enhanceNavDropdownButton);
      this.enhancers.add(".masonry", enhanceMasonryGrid);
    }
    async beforeRouting() {
      return await polyfillsLoaded;
    }
    render() {
      return x`
        <header>
          <h1 ${n6(this.#h1)}></h1>
          <label id="omnibox"
            ><span data-label>Omnibox</span
            ><input
              @focus=${(e5) => {
        AutoComplete.connect(e5, this.autoCompleteOptions);
      }}
              type="search"
          /></label>
        </header>
        <aside ${n6(this.#aside)}></aside>
        <main>${super.render()}</main>
        <footer>&copy; ${(/* @__PURE__ */ new Date()).getFullYear()} Neerventure</footer>
      `;
    }
    firstUpdated() {
      super.firstUpdated();
      this.addMenu();
      this.on("routecomplete", () => {
        this.#h1.value.textContent = this.activeRoute?.name;
      });
    }
    addMenu() {
      const menu = document.createElement("menu");
      for (const page of this.config.pages) {
        const li = parseHTML(
          /*html*/
          `<li><a href="${page.path}">${page.name}</a></li>`
        )[0];
        menu.appendChild(li);
      }
      this.#aside.value.appendChild(menu);
    }
    get autoCompleteOptions() {
      return {
        // debug: true,
        categories: {
          Search: {
            trigger: (options) => {
              return options.search.length > 0;
            },
            getItems: (options) => {
              const fltr = AutoComplete.textFilter(options);
              return ["Pete", "Jane", "John", "Maria", "Robert", "Zack"].filter(fltr).map((i6) => {
                return { text: i6, description: "User name", icon: "menu" };
              });
            }
          }
        }
      };
    }
  }
);
/*! Bundled license information:

@lit-labs/ssr-dom-shim/lib/element-internals.js:
  (**
   * @license
   * Copyright 2023 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

@lit-labs/ssr-dom-shim/index.js:
  (**
   * @license
   * Copyright 2019 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

@lit/reactive-element/node/css-tag.js:
  (**
   * @license
   * Copyright 2019 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/lit-html.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-element/lit-element.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/is-server.js:
  (**
   * @license
   * Copyright 2022 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directive-helpers.js:
  (**
   * @license
   * Copyright 2020 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directive.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/async-directive.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directives/private-async-helpers.js:
  (**
   * @license
   * Copyright 2021 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directives/until.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directives/repeat.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directives/ref.js:
  (**
   * @license
   * Copyright 2020 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)
*/
//# sourceMappingURL=app.js.map
